## class SG_EXPORT osg::ClipPlane

> ClipPlane state class which encapsulates OpenGL glClipPlane() functionality

## Inheritance:

### Public Methods

ClipPlane()
inline ClipPlane(unsigned int no, const Vec4& plane)
inline ClipPlane(unsigned int no, const Plane& plane)
inline ClipPlane(unsigned int no, double a, double b, double c, double d)
ClipPlane(const ClipPlane& cp, const CopyOp& copyop=CopyOp::SHALLOW_COPY)
  Copy constructor using CopyOp to manage deep vs shallow copy
META_StateAttribute(osg, ClipPlane, (Type)(CLIPPLANE+_clipPlaneNum))
virtual int compare(const StateAttribute& sa) const
  return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs
virtual void getAssociatedModes(std::vector<GLMode>& modes) const
void setClipPlane(const Vec4& plane)
  Set the clip plane, using a Vec4 to define plane.
void setClipPlane(const Plane& plane)
  Set the clip plane, using a Plane to define plane.
void setClipPlane(const double* plane)
  Set the clip plane, using a double[4] to define plane.
void setClipPlane(double a, double b, double c, double d)
  Set the clip plane, using a a to define plane.
void getClipPlane(Vec4& plane) const
  Get the clip plane, values entered into a Vec4 passed to the getClipPlane.
void getClipPlane(Plane& plane) const
  Get the clip plane, values entered into a Plane passed to the getClipPlane.
void getClipPlane(double* plane) const
  Get the clip plane, values entered into a double[4] passed to the getClipPlane.
void setClipPlaneNum(unsigned int num)
  Set the clip plane number.
unsigned int getClipPlaneNum() const
  Get the clip plane number.
virtual void apply(State& state) const
  Apply the clip plane's state to the OpenGL state machine.

### Protected Fields

double _clipPlane[4]
unsigned int _clipPlaneNum

### Protected Methods

virtual ~ClipPlane()

### Inherited from StateAttribute:

### Public Methods

virtual Object* cloneType() const
virtual Object* clone(const CopyOp&) const
virtual bool isSameKindAs(const Object* obj) const
virtual const char* libraryName() const
virtual const char* className() const
virtual Type getType() const
virtual bool isTextureAttribute() const
bool operator < (const StateAttribute& rhs) const
bool operator == (const StateAttribute& rhs) const
bool operator != (const StateAttribute& rhs) const
virtual void compile(State&) const

### Public Members

typedef GLenum GLMode
typedef unsigned int GLModeValue
typedef unsigned int OverrideValue
enum Values
typedef unsigned int Type
enum Types

### Inherited from Object:

### Public Methods

inline void setDataVariance(DataVariance dv)
inline DataVariance getDataVariance() const
inline void setUserData(Referenced* obj)
inline Referenced* getUserData()
inline const Referenced* getUserData() const

### Public Members

enum DataVariance

### Protected Fields

DataVariance _dataVariance
ref_ptr<Referenced> _userData

### Inherited from Referenced:

### Public Methods

inline Referenced& operator = (Referenced&)
static void setDeleteHandler(DeleteHandler* handler)
static DeleteHandler* getDeleteHandler()
inline void ref() const
inline void unref_nodelete() const
inline int referenceCount() const
inline void unref() const

### Protected Fields

mutable int _refCount

## Documentation

> ClipPlane state class which encapsulates OpenGL glClipPlane() functionality

`ClipPlane()`

`inline ClipPlane(unsigned int no, const Vec4& plane)`

`inline ClipPlane(unsigned int no, const Plane& plane)`

`inline ClipPlane(unsigned int no, double a, double b, double c, double d)`

`ClipPlane(const ClipPlane& cp, const CopyOp& copyop=CopyOp::SHALLOW_COPY)`
  Copy constructor using CopyOp to manage deep vs shallow copy

`META_StateAttribute(osg, ClipPlane, (Type)(CLIPPLANE+_clipPlaneNum))`

`virtual int compare(const StateAttribute& sa) const`
  return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs

`virtual void getAssociatedModes(std::vector<GLMode>& modes) const`

`void setClipPlane(const Vec4& plane)`
  Set the clip plane, using a Vec4 to define plane.

`void setClipPlane(const Plane& plane)`
  Set the clip plane, using a Plane to define plane.

`void setClipPlane(const double* plane)`
  Set the clip plane, using a double[4] to define plane.

`void setClipPlane(double a, double b, double c, double d)`
  Set the clip plane, using a a to define plane.

`void getClipPlane(Vec4& plane) const`
  Get the clip plane, values entered into a Vec4 passed to the getClipPlane.

`void getClipPlane(Plane& plane) const`
  Get the clip plane, values entered into a Plane passed to the getClipPlane.

`void getClipPlane(double* plane) const`
  Get the clip plane, values entered into a double[4] passed to the getClipPlane.

`void setClipPlaneNum(unsigned int num)`
  Set the clip plane number.

`unsigned int getClipPlaneNum() const`
  Get the clip plane number.

`virtual void apply(State& state) const`
  Apply the clip plane's state to the OpenGL state machine.

`virtual ~ClipPlane()`

`double _clipPlane[4]`

`unsigned int _clipPlaneNum`

This class has no child classes.

Alphabetic index HTML hierarchy of classes or Java

This page was generated with the help of DOC++.